type arbre = Vide | N of arbre * int * arbre;;

(*1*)

(*on trouve 2.25 et 2.8*)

(*2*)

let cout f t =
	let rec aux prof a =
		match a with
			| Vide -> 0.
			| N (g, x, d) -> aux (prof +. 1.) g +. (1. +. prof) *. f.(x) +. aux (prof +. 1.) d
	in aux 0. t;;

(* La fonction aux calcule le cout d'un sous-arbre a dont la racine est a une 
profondeur prof dans l'arbre total t*)


(*3.c*)

let tableauxF f = 
  let n = (Array.length f) - 1 in
  let t = Array.make_matrix (n + 1) (n + 1) 0. in
  for i = 0 to n do
    for j = i+1 to n  do
      t.(i).(j) <- t.(i).(j-1) +. f.(j)
    done;
  done;
  t;;

(*3.d*)
let tableauxAbrOpt f =
  let n = (Array.length f) - 1 in
  let c = Array.make_matrix (n + 1) (n + 1) 0. in
  let r = Array.make_matrix (n + 1) (n + 1) 0 in
  let t = tableauxF f in
  (* on remplit le tableau par diagonale pour, lors du calcul de c.(i).(j) avoir
  déjà calculé c.(i).(k-1) et c.(k).(j) pour k entre i+1 et j*)
  for l = 1 to n do
  for i = 0 to (n-l) do
  let j = i+l  in
      let kmin = ref (i + 1) in
      let cmin = ref (c.(i + 1).(j)) in
      for k = i + 2 to j do
        let temp = c.(i).(k - 1) +. c.(k).(j) in
        if temp < !cmin then
        (kmin := k;
          cmin := temp
        )
      done;
      c.(i).(j) <- t.(i).(j) +. !cmin;
      r.(i).(j) <- !kmin
    done;
  done;
  r, c;;
				
				
let f = [|0. ; 0.1; 0.4; 0.2; 0.15 ; 0.1 ; 0.05|];;

tableauxAbrOpt f;;

let arbOpt f =
	let r, c = tableauxAbrOpt f in
		let n = (Array.length f) - 1 in
			let rec aux i j =
				if i = j then Vide
				else let k = r.(i).(j) in
						N (aux i (k - 1), k, aux k j)
			in aux 0 n;;

arbOpt f;;

(* On obtient
N (N (Vide, 1, Vide), 2,
 N (N (Vide, 3, Vide), 4, N (Vide, 5, N (Vide, 6, Vide))))
 *)